<!-- -*- sgml -*- -->
<!DOCTYPE spec PUBLIC "-//Ken MacLeod//DTD GSF Spec//EN">
<spec>
  <head></head>
  
  <rules>
    <rule><query/BOOK ARTICLE/  <isa/Document/
      <rules>
	<rule><query/BOOKINFO/      <isa/Holder/
	<rule><query/BOOKBIBLIO ARTHEADER/
	                            <isa/Holder/
	  <rules>
	    <rule><query/TITLE/         <save/{title}/
	    <rule><query/TITLEABBREV/   <save/{title_abbr}/
	    <rule><query/SUBTITLE/      <save/{sub_title}/
	    <rule><query/EDITION/       <save/{edition}/
	    <rule><query/AUTHORGROUP/   <isa/Holder/
	    <rule><query/CORPAUTHOR/    <isa/Author/
	      <push/{authors}/
	    <rule><query/AUTHOR/
	      <rules>
		<rule><query/HONORIFIC/     <save/{nameprefix}/
		<rule><query/FIRSTNAME/     <save/{givenname}/
		<rule><query/SURNAME/       <save/{familyname}/
		<rule><query/LINEAGE/       <save/{namesuffix}/
		<rule><query/OTHERNAME/     <save/{formattedname}/
		<rule><query/AFFILIATION/   <isa/Holder/
		  <rules>
		    <rule><query/SHORTAFFIL/    <save/{orgnameabbr}/
		    <rule><query/JOBTITLE/      <save/{title}/
		    <rule><query/ORGNAME/       <save/{orgname}/
		    <rule><query/ORGDIV/        <push/{orgunit}/
		    <rule><query/ADDRESS/       <isa/Holder/
		      <rules>
			<rule><query/STREET/        <save/{street}/
			<rule><query/POB/           <save/{postofficeaddress}/
			<rule><query/POSTCODE/      <save/{postalcode}/
			<rule><query/CITY/          <save/{locality}/
			<rule><query/STATE/         <save/{region}/
			<rule><query/COUNTRY/       <save/{country}/
			<rule><query/PHONE/         <save/{phone}/
			<rule><query/FAX/           <save/{fax}/
			<rule><query/EMAIL/         <save/{email}/
			<rule><query/OTHERADDR/     <save/{otheraddr}/
		      </rules> <!-- ADDRESS -->
		    </rule>
		  </rules> <!-- AFFILIATION -->
		</rule>
		<rule><query/AUTHORBLURB/   <save/{authorblurb}/
		<rule><query/CONTRIB/       <save/{contrib}/
	      </rules>
	      <push/{authors}/     <isa/Author/
		 <!-- AUTHOR -->
	    </rule>
	    <rule><query/COPYRIGHT/   <isa/DB_Copyright/
	      <rules>
		<rule><query/YEAR/      <push/{years}/
		<rule><query/HOLDER/       <push/{holders}/
		</rule>
	      </rules> <!-- COPYRIGHT -->
	    </rule>
	    <rule><query/ARTPAGENUMS/   <save/{artpagenums}/
	  </rules> <!-- BOOKBIBLIO ARTHEADER -->

	<rule><query/LEGALNOTICE/   <isa/Holder/
      </rules>
    </rule> <!-- BOOK ARTICLE -->

    <rule><query/PARA/           <isa/Paragraph/
    <rule><query/LITERALLAYOUT/  <isa/NoFill/
    <rule><query/SYNOPSIS/       <isa/NoFill/
    <rule><query/PROGRAMLISTING/ <isa/Screen/
    <rule><query/SCREEN/         <isa/Screen/
    <rule><query/BRIDGEHEAD/     <isa/Bridge/
    <rule><query/IMPORTANT/      <isa/Admonition ('type' => 'Important')/
    <rule><query/WARNING/        <isa/Admonition ('type' => 'Warning')/
    <rule><query/NOTE/           <isa/Admonition ('type' => 'Note')/
    <rule><query/HIGHLIGHTS/     <isa/Admonition ('type' => 'Highlights')/
    <rule><query/FIGURE/         <isa/Formal ('type' => 'Figure')/
    <rule><query/EXAMPLE/        <isa/Formal ('type' => 'Example')/
    <rule><query/TABLE/          <isa/Formal ('type' => 'Table')/

    <rule><query/TGROUP/         <isa/Table/
      <rules>
	<rule><query/THEAD/        <isa/TablePart ('type' => 'head')/
	<rule><query/TBODY/        <isa/TablePart ('type' => 'body')/
	<rule><query/TFOOT/        <isa/TablePart ('type' => 'foot')/
	<rule><query/ROW/          <isa/TableRow/
	<rule><query/ENTRY/        <isa/TableEntry/
	</rule>
      </rules> <!-- TGROUP -->

    <rule><query/CHAPTER/    <isa/Section (type => 'Chapter')/
    <rule><query/PREFACE/    <isa/Section (type => 'Preface')/
    <rule><query/SECT1 SECT2 SECT3 SECT4 SECT5/
                             <isa/Section/
    <rule><query/APPENDIX/   <isa/Section (type => 'Appendix')/

    <rule><query/TITLE/      <save/{title}/

    <rule><query/ITEMIZEDLIST/    <isa/List ('type' => 'itemized')/
    <rule><query/VARIABLELIST/    <isa/List ('type' => 'variable')/
    <rule><query/ORDEREDLIST/    <isa/List ('type' => 'ordered')/

    <rule><query/LISTITEM/    <isa/ListItem/
    <rule><query/VARLISTENTRY/ <isa/Holder/
    <rule><query/TERM/       <isa/ListTerm/

      <!-- XXX this should use a CDATAATTR element -->
    <rule><query/ULINK/ <isa>URL ('url' => new_arr Text::GDO::SGML::Event ('cdata', <attr/URL/, undef, undef))</isa>
    <rule><query/LINK/ <isa>XRef ('link' => <attr/LINKEND/)</isa>
    <rule><query/XREF/ <isa>XRefEnd ('link' => <attr/LINKEND/)</isa>

    <rule><query/EMPHASIS/       <isa/Inline_Emphasis/
    <rule><query/QUOTE/          <isa/Inline_Quote/
    <rule><query/LITERAL/        <isa/Inline_Literal/
    <rule><query/FILENAME/       <isa/Inline_Literal/
    <rule><query/INTERFACE/      <isa/Inline_Literal/
    <rule><query/OPTION/         <isa/Inline_Literal/
    <rule><query/REPLACEABLE/    <isa/Inline_Replaceable/
    <rule><query/OPTIONAL/       <isa/Inline_Replaceable/
    <rule><query/LINEANNOTATION/ <isa/Inline_Emphasis/
    <rule><query/SGMLTAG/        <isa/DB_SGMLTag/
    <rule><query/APPLICATION/    <isa/Inline_Package/
    <rule><query/ACRONYM/        <isa/Inline_Package/
    <rule><query/GLOSSTERM/      <isa/Inline_Index/
    <rule><query/SYMBOL/         <isa/Inline_Literal/
    <rule><query/COMMAND/        <isa/Inline_Literal/
    <rule><query/PARAMETER/      <isa/Inline_Replaceable/
    <rule><query/CLASSNAME/      <isa/Inline_Literal/
    <rule><query/RETURNVALUE/    <isa/Inline_Literal/
    <rule><query/FOREIGNPHRASE/  <isa/Inline_Emphasis/
    <rule><query/FIRSTTERM/      <isa/Inline_Emphasis/
    <rule><query/SYSTEMITEM/     <isa/Inline_Literal/
    <rule><query/USERINPUT/      <isa/Inline_Literal/
    <rule><query/COMPUTEROUTPUT/ <isa/Inline_Literal/
  </rules>

  <stuff>
sub save_attr {
    my ($self, $data, $event) = @_;
    my ($parent) = $data->{'diversion'}[-1];
    my ($id, $id_type, $id_attr);

    if ($id_attr = $event->data->attribute ('ID')) {
        $id_type = $id_attr->type;
        if ($id_type ne 'IMPLIED') {
            $id = $id_attr->value;
            $parent->{'id'} = $id;
            new Text::GDO::Reference ($data, 'object' => $parent, 'id' => $id);
        }
    }
}

package Text::GDO::DB_SGMLTag;
@Text::GDO::DB_SGMLTag::ISA = qw{Text::GDO::Inline};

sub as_string {
    my ($self, $context) = @_;

    return "<" . $self->{'source'}->as_string($context) . ">";
}

package Text::GDO::DB_Copyright;
@Text::GDO::DB_Copyright::ISA = qw{Text::GDO::DocObject};

sub html_to {
    my ($self, $context) = @_;

    return "&lt;P>" . $self->as_string($context) . "&lt;/P>\n";
}

sub ascii_to {
    my ($self, $context) = @_;
    my (@blocks);

    return [$context->before, $context->after,
            $self->fmt ($self->as_string($context),
                        $context->indent, $context->rindent,
                        $context->line_width, $context->justify)];
}

sub as_string {
    my ($self, $context) = @_;
    my ($data) = "Copyright " . $context->charent('[copy  ]') . " ";

    my ($year, @years);
    foreach $year (@{$self->{'years'}}) {
        push (@years, $year->as_string($context));
    }
    $data .= join (", ", @years);

    $data .= " ";

    my ($holder, @holders);
    foreach $holder (@{$self->{'holders'}}) {
        push (@holders, $holder->as_string($context));
    }
    $data .= join (", ", @holders);

    return $data;
}
</stuff>
</spec>
