# -*- perl -*-
#
# Copyright (C) 1996 Ken MacLeod
# See the file COPYING for distribution terms.
#

require "sroff-ascii.pl";
require "sroff-html.pl";

#
#
#
$tests->{'sroff'}{'source'}{"dummy"} = <<'EOTEST';
<!DOCTYPE sroff SYSTEM "test-sroff.dtd">
<sroff>
</sroff>
EOTEST

#
# test formatting of a paragraph
#
$tests->{'sroff'}{'source'}{"medium-paragraph"} = <<'EOTEST';
<!DOCTYPE par SYSTEM "test-sroff.dtd">
<par>GDO's design uses sgmls to validate and parse the
document instance (doesn't everybody :-), it then maps document
entities to generalized entities that are implemented as
object-methods.  A stack (single-line hierarchy) of object classes
implements the methods, with the base-class being most general, and
subsequent classes providing more detailed processing.  The SROFF
example above looks like this internally:</par>
EOTEST

#
# test section levels
#
$tests->{'sroff'}{'source'}{"sections-titles"} = <<'EOTEST';
<!DOCTYPE sroff SYSTEM "test-sroff.dtd">
<sroff>
  <section><title>Section One</title>
    <section><title>Section One.One</title>
      <section><title>Section One.One.One</title>
      </section>
      <section><title>Section One.One.Two</title>
      </section>
    </section>
    <section><title>Section One.Two</title>
    </section>
  </section>
  <section><title>Section Two</title>
    <section><title>Section Two.One</title>
    </section>
  </section>
</sroff>
EOTEST

#
# test title page elements
#
$tests->{'sroff'}{'source'}{"title-page"} = <<'EOTEST';
<!DOCTYPE sroff SYSTEM "test-sroff.dtd">
<sroff>
  <head>

    <structtitle>Test Title</structtitle>
    <structsubtitle>Test SubTitle</structsubtitle>
    <structdate>Test Date</structdate>
    <structauthor>Test Author</structauthor>
    <abstract>Test Abstract</abstract>
    <copyright>Test Copyright</copyright>
    <structextra>Test Extra</structextra>

  </head>
</sroff>
EOTEST

#
# Test multiple tags, test with/without paragraphs
#
$tests->{'sroff'}{'source'}{"variable-list"} = <<'EOTEST';
<!DOCTYPE sroff SYSTEM "test-sroff.dtd">
<sroff>
  <dl>
    <listterm>term1a</listterm>
    <listterm>term1b</listterm>
    <listitem>Without PAR tag.</listitem>

    <listterm>term2</listterm>
    <listitem>
      <par>With PAR tag, first paragraph.</par>
      <par>Second paragraph.</par>
    </listitem>
  </dl>
</sroff>
EOTEST

#
# Test URL formatting
#
$tests->{'sroff'}{'source'}{"url"} = <<'EOTEST';
<!DOCTYPE sroff SYSTEM "test-sroff.dtd">
<sroff>
  <par><url url="http://bitsko.slc.ut.us/">Home of GDO</url></par>
</sroff>
EOTEST

#
# test links
#
$tests->{'sroff'}{'source'}{"links"} = <<'EOTEST';
<!DOCTYPE sroff SYSTEM "test-sroff.dtd">
<sroff>
  <section id=sect1><title>Section One</title>
    <section id=sect11><title>Section One.One</title>
      <section id=sect111><title>Section One.One.One</title>
        <par>This links to <link linkend=sect12>Section One.Two</link>.</par>
      </section>
      <section id=sect112><title>Section One.One.Two</title>
        <par>This links to <link linkend=sect1>Section One</link>.</par>
      </section>
    </section>
    <section id=sect12><title>Section One.Two</title>
    </section>
  </section>
</sroff>
EOTEST

#
# test block (SCREEN) within paragraph
#
$tests->{'sroff'}{'source'}{"block-in-paragraph"} = <<'EOTEST';
<!DOCTYPE sroff SYSTEM "test-sroff.dtd">
<sroff>
  <par>GDO's design uses sgmls to validate and parse the
document instance (doesn't everybody :-), it then maps document
entities to generalized entities that are implemented as
object-methods.  A stack (single-line hierarchy) of object classes
implements the methods, with the base-class being most general, and
subsequent classes providing more detailed processing.  The SROFF
example above looks like this internally:
    <screen>
Line 1
Line 2
</screen>
  </par>
</sroff>
EOTEST

#
# Quoting test
#
$tests->{'sroff'}{'source'}{"quoting"} = <<'EOTEST';
<!DOCTYPE sroff SYSTEM "test-sroff.dtd">
<sroff>
  <par>
    <screen>some data
      <qtt>quoted data</qtt>
    </screen>
    <screen>more data
      <qtt>more quoted data</qtt>
    </screen>
  </par>
</sroff>
EOTEST

#
# Quoting test
#
$tests->{'sroff'}{'source'}{"noadjust"} = <<'EOTEST';
<!DOCTYPE sroff SYSTEM "test-sroff.dtd">
<sroff>
  <par>
    <noadjust>some data
      <qtt>quoted data</qtt>
    </noadjust>
    <noadjust>more data
      <qtt>more quoted data</qtt>
    </noadjust>
  </par>
</sroff>
EOTEST

1;
