# -*- perl -*-
#
# Copyright (C) 1996 Ken MacLeod
# See the file COPYING for distribution terms.
#

# XXX doesn't work under 0.4

require "sroff-source.pl";
$outputType = "SROFF::TROFF";
$extension = "troff";

sub Check {
    system "nroff -mgs defrag-out >/dev/null 2>check-out";
}

######################################################################
$expected{"dummy"} = <<'EOTEST';
EOTEST

######################################################################
$expected{"block-in-paragraph"} = <<'EOTEST';
.LP
DTD Fragments design uses sgmls to validate and parse the
document instance (doesn't everybody :-), it then maps document
entities to generalized entities that are implemented as
object-methods.  A stack (single-line hierarchy) of object classes
implements the methods, with the base-class being most general, and
subsequent classes providing more detailed processing.  The SROFF
example above looks like this internally:
.LP
.nf
.ft CW
Line 1
Line 2
EOTEST

######################################################################
$expected{"links"} = <<'EOTEST';
.NH 1
Section One
.NH 2
Section One.One
.NH 3
Section One.One.One
.LP
This links to Section One.Two\&.
.NH 3
Section One.One.Two
.LP
This links to Section One\&.
.NH 2
Section One.Two
EOTEST

######################################################################
$expected{"medium-paragraph"} = <<'EOTEST';
.LP
DTD Fragments design uses sgmls to validate and parse the
document instance (doesn't everybody :-), it then maps document
entities to generalized entities that are implemented as
object-methods.  A stack (single-line hierarchy) of object classes
implements the methods, with the base-class being most general, and
subsequent classes providing more detailed processing.  The SROFF
example above looks like this internally:
EOTEST

######################################################################
$expected{"noadjust"} = <<'EOTEST';
.LP
.nf
some data
      \f(CWquoted data\fR
.sp 1v
more data
      \f(CWmore quoted data\fR
EOTEST

######################################################################
$expected{"quoting"} = <<'EOTEST';
.LP
.nf
.ft CW
some data
      \f(CWquoted data\f(CW
.sp 1v
more data
      \f(CWmore quoted data\f(CW
EOTEST

######################################################################
$expected{"sections-titles"} = <<'EOTEST';
.NH 1
Section One
.NH 2
Section One.One
.NH 3
Section One.One.One
.NH 3
Section One.One.Two
.NH 2
Section One.Two
.NH 1
Section Two
.NH 2
Section Two.One
EOTEST

######################################################################
$expected{"title-page"} = <<'EOTEST';
.TL
Test Title
.AU
Test Author
.AB
.LP
Test Abstract
.AE
.LP
Test Extra
.LP
Test Copyright
EOTEST

######################################################################
$expected{"url"} = <<'EOTEST';
.LP
\fIHome of DTD Fragments\fR (http://bitsko.slc.ut.us/)
EOTEST

######################################################################
$expected{"variable-list"} = <<'EOTEST';
.IP "term1a"
.IP "term1b"
Without PAR tag.
.IP "term2"
With PAR tag, first paragraph.
.IP
Second paragraph.
EOTEST

1;
